using System;
using ProtoBuf;
using Fantasy;
using System.Linq;
using System.Reflection;
using System.Collections.Generic;
using System.Collections.Concurrent;
using Fantasy.Serialize;
using Fantasy.ConfigTable;

namespace NBF
{
    [ProtoContract]
    public sealed partial class ReelConfig : ASerialize, IProto, IConfigTable
    {
    
		[ProtoMember(1)]
		public uint Id { get; set; } // Id
		[ProtoMember(2)]
		public string Model { get; set; } // 模型
		[ProtoMember(3)]
		public uint Type { get; set; } // 类型
		[ProtoMember(4)]
		public float[] GearRatio { get; set; } = Array.Empty<float>(); // 组件比
		[ProtoMember(5)]
		public uint Size { get; set; } // 尺寸
		[ProtoMember(6)]
		public uint Strength { get; set; } // 强度  
        [ProtoIgnore]
        public uint Key => Id;
        
        #region Static
        
        private static ConfigContext<ReelConfig> Context => ConfigTableHelper.Table<ReelConfig>();

        public static ReelConfig Get(uint key)
        {
            return Context.Get(key);
        }

        public static ReelConfig Get(Predicate<ReelConfig> match)
        {
            return Context.Get(match);
        }
        
        public static ReelConfig Fist()
        {
            return Context.Fist();
        }

        public static ReelConfig Last()
        {
            return Context.Last();
        }

        public static ReelConfig Fist(Predicate<ReelConfig> match)
        {
            return Context.Fist(match);
        }

        public static ReelConfig Last(Predicate<ReelConfig> match)
        {
            return Context.Last(match);
        }
        
        public static int Count()
        {
            return Context.Count();
        }

        public static int Count(Func<ReelConfig, bool> predicate)
        {
            return Context.Count(predicate);
        }

        public static List<ReelConfig> GetList()
        {
            return Context.GetList();
        }

        public static List<ReelConfig> GetList(Predicate<ReelConfig> match)
        {
            return Context.GetList(match);
        }
        public static void ParseJson(Newtonsoft.Json.Linq.JArray arr)
        {
            ConfigTableHelper.ParseLine<ReelConfig>(arr);
        }
        #endregion
    }
}